#ifndef __PC_PKMEM_H
#define __PC_PKMEM_H

#define EMPTY                   0x10000000
#define FULL                    0x20000000
#define COMPLETED               0x40000000
#define RESET_STATUS(ptr)       *((unsigned int *) ptr) &= ~(EMPTY | FULL | COMPLETED)
#define SET_STATUS(ptr, flag)   *((unsigned int *) ptr) = flag
#define SET_SIZE(ptr, size)     *((unsigned int *) ptr) |= size
#define GET_STATUS(ptr)         *((unsigned int *) ptr)
#define PK_SHM_NAME             "/mypkmem"
#define PK_SHM_SIZE             1024

#ifdef DEBUG
#define dbg(str)                printf("%s\n", str); fflush(stdout);
#else
#define dbg(str)
#endif

extern long long cpucycles(void);

#endif
