#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

#define FILENAME	"file"
#define TIMES		4096
#define HZ	        1599008000.0

extern long long cpucycles(void);

int main()
{
	long long t;
	double seconds, ps = TIMES;
	int fd, err, *addr, idx;
	struct stat fbuf;

	err = -1;
	idx = 0;
	fd = open(FILENAME, O_RDWR);
        if(fd < 0) { perror("open"); goto out; }
	if(fstat(fd, &fbuf) < 0) { perror("fstat"); goto out; }

        addr = (int *)mmap(0, fbuf.st_size, PROT_NONE, MAP_SHARED, fd, (off_t) 0);
	if(!addr) { perror("mmap"); goto out; }
	
	t = cpucycles();
	while(idx++ < TIMES) {
		if(mprotect(addr, fbuf.st_size, PROT_READ|PROT_WRITE) < 0) { perror("mprotect"); goto out; }
		if(mprotect(addr, fbuf.st_size, PROT_NONE) < 0) { perror("mprotect"); goto out; }
	}
	t = cpucycles() - t;

	if(munmap(addr, fbuf.st_size) < 0) { perror("munmap"); goto out; }
	seconds = (double) t / (double) HZ;
	printf("mprotect/unprotect pairs/second: %lf\n", ps/seconds);
	err = 0;
out:
	return err;
}
