#include "pc-fifo.h"

int main(int argc, char *argv[])
{
	int fd, err;
	unsigned long filesz;
	long long t;
	double seconds, tp;
	char *buffer;

	err = -1;
	filesz = 1 * MEGABYTE;
        if(argc != 1) { printf("usage: %s \n", argv[0]); goto out; }

	buffer = malloc(filesz);
	if(!buffer) { perror("malloc"); goto out; }

	fd = open(FIFO_FILE, O_RDONLY);
	if(fd < 0) { perror("open"); goto out; }

	t = cpucycles();
	if(read(fd, buffer, filesz) < 0) { perror("read"); goto out; }
	t = cpucycles() - t;

	if(close(fd) < 0) { perror("close"); goto out; }

	// Display the stats
	seconds = (double) t / (double) HZ;
	tp = (double) filesz / (double) MEGABYTE;
	tp = tp / seconds;
	printf("MB/Second: %.*lf\n", 2, tp);
	err = 0;
out:
	return err;
}

