#include "pc-fifo.h"

int main(int argc, char *argv[])
{
	int fd, fdfifo, err; 
	unsigned long filesz;
	char *start_mmap;
	const char *filename;
	struct stat fbuf;

	err = -1;
	if(argc != 2) {
		printf("Usage: %s <file>\n", argv[0]);
		goto out;
	}

	// Create the FIFO
        if(umask(0) < 0) { perror("umask"); goto out; }
        if(mknod(FIFO_FILE, S_IFIFO | 0666, 0) < 0) { 
		perror("mknod"); 
		goto skip;
		if(errno == EEXIST) goto skip;
		goto out; 
	}

skip:
	// open, get size of file, mmap the file into memory
	filename = argv[1];
	fd = open(filename, O_RDONLY);
	if(fd < 0) { perror("open"); goto out; }
	if(fstat(fd, &fbuf) < 0) { perror("fstat"); goto out; }
	filesz = fbuf.st_size;
	start_mmap = mmap(NULL, filesz, PROT_READ, MAP_PRIVATE, fd, 0);
	if(start_mmap == MAP_FAILED) { perror("mmap"); goto out; }

	// Open the FIFO
	fdfifo = open(FIFO_FILE, O_WRONLY);
	if(fdfifo < 0) { perror("open"); goto out; }
	
	// Write the contents of the file into the FIFO
	if(write(fdfifo, start_mmap, filesz) < 0) { perror("write"); goto out; }

	// Wrap up
	if(munmap(start_mmap, filesz) < 0) { perror("munmap"); goto out; }
	if(close(fd) < 0) { perror("close"); goto out; }
	if(close(fdfifo) < 0) { perror("close"); goto out; }

	err = 0;
out:
	return err;
}
